// DS102Dlg.cpp : Implementation   File
//
//------------------------------------------------------------------------------------
//
//		Sample program for controlling DS102/DS112 series controllers.(Ver.1.00)
//
//		This Sample Program uses MSComm Control that is provided from MicroSoft.
//		Please use the Cross Cable that is designated by SURUGA SEIKI for RS-232C use.
//------------------------------------------------------------------------------------

#include "stdafx.h"
#include "DS102.h"
#include "DS102Dlg.h"
#include "SetupDlg.h"
#include "CommDlg.h"
#include <comdef.h>
#include <math.h>

#define LIMIT_TIME  2.0

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Version Information use [CAboutDlg]

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA


	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// 
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDS102Dlg Dialog

CDS102Dlg::CDS102Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDS102Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDS102Dlg)
	m_dPosition1 = 0.0;
	m_dPosition2 = 0.0;
	m_uiSpeed1 = 1000;
	m_uiSpeed2 = 1000;
	m_dStep1 = 0.0;
	m_dStep2 = 0.0;
	m_strUnit1 = _T("");
	m_strUnit2 = _T("");
	//}}AFX_DATA_INIT
	
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDS102Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDS102Dlg)
	DDX_Control(pDX, IDC_CW2, m_btnCW2);
	DDX_Control(pDX, IDC_CW1, m_btnCW1);
	DDX_Control(pDX, IDC_CCW2, m_btnCCW2);
	DDX_Control(pDX, IDC_CCW1, m_btnCCW1);
	DDX_Control(pDX, IDC_MSCOMM1, m_MSComm);
	DDX_Text(pDX, IDC_POSITION1, m_dPosition1);
	DDX_Text(pDX, IDC_POSITION2, m_dPosition2);
	DDX_Text(pDX, IDC_SPEED1, m_uiSpeed1);
	DDX_Text(pDX, IDC_SPEED2, m_uiSpeed2);
	DDX_Text(pDX, IDC_STEP1, m_dStep1);
	DDV_MinMaxDouble(pDX, m_dStep1, -99999999., 99999999.);
	DDX_Text(pDX, IDC_STEP2, m_dStep2);
	DDV_MinMaxDouble(pDX, m_dStep2, -99999999., 99999999.);
	DDX_Text(pDX, IDC_UNIT1, m_strUnit1);
	DDX_Text(pDX, IDC_UNIT2, m_strUnit2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDS102Dlg, CDialog)
	//{{AFX_MSG_MAP(CDS102Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONT, OnCont)
	ON_BN_CLICKED(IDC_STEP, OnStep)
	ON_BN_CLICKED(IDC_POINT, OnPoint)
	ON_BN_CLICKED(IDC_ORG, OnOrg)
	ON_COMMAND(IDC_MENU_AXIS1, OnMenuAxis1)
	ON_COMMAND(IDC_MENU_AXIS2, OnMenuAxis2)
	ON_BN_CLICKED(IDC_EMG, OnEmg)
	ON_BN_CLICKED(IDC_CLEAR1, OnClear1)
	ON_BN_CLICKED(IDC_CLEAR2, OnClear2)
	ON_WM_TIMER()
	ON_COMMAND(IDC_END, OnEnd)
	ON_COMMAND(IDC_MENU_COMM, OnMenuComm)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MY_LBUTTON_DOWN,OnDown)
	ON_MESSAGE(WM_MY_LBUTTON_UP,OnUp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDS102Dlg 

BOOL CDS102Dlg::OnInitDialog()
{
	m_btnCW1.SubclassDlgItem(IDC_CW1,this);
	m_btnCW2.SubclassDlgItem(IDC_CW2,this);
	m_btnCCW1.SubclassDlgItem(IDC_CCW1,this);
	m_btnCCW2.SubclassDlgItem(IDC_CCW2,this);

	CDialog::OnInitDialog();
	
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}	
	
	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	// Initialization of a variable
	iMoveStyle = 0;
	nTimerID = 1;
	iTimer =0;

	// Initialization of a Control
	((CButton*)GetDlgItem(IDC_CONT))->SetCheck(1);

	OnEmg();
	SetUnit(1);
	SetUnit(2);
	GetPosition(1);
	GetPosition(2);
	GetStatus3(1);
	GetStatus3(2);
	GetStatus1(1);
	GetStatus1(2);
	GetStatus2(1);
	GetStatus2(2);
	GetFSpeed(1);
	GetFSpeed(2);

	UpdateStatus();
	UpdateData(FALSE);

	//
	// Initialization processing of a Comm port is performed.
	//
	iCommPort = 1;
	SetCommPort(iCommPort);

	return TRUE;
}

void CDS102Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// 
// 
// 

void CDS102Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// 
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// 
// 
HCURSOR CDS102Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDS102Dlg::OnOK() 
{

	//CDialog::OnOK();	// 
}

void CDS102Dlg::OnCancel() 
{
	// When an End is pushed
	Send("STOP 0");
	if( MessageBox("It ends. Is it all right?","End check",MB_OKCANCEL) == IDOK){
		if(CCommDlg::bPortOpenFlg == TRUE)
			m_MSComm.SetPortOpen(FALSE);
		CDialog::OnCancel();
	}
}

void CDS102Dlg::OnCont() 
{
// Mode(continue)
	iMoveStyle = 0;
	((CButton*)GetDlgItem(IDC_CW1))->SetWindowText("< (+) ");
	((CButton*)GetDlgItem(IDC_CW2))->SetWindowText("< (+) ");
	((CButton*)GetDlgItem(IDC_CCW1))->SetWindowText(" (-) >");
	((CButton*)GetDlgItem(IDC_CCW2))->SetWindowText(" (-) >");

	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->EnableWindow(FALSE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->EnableWindow(FALSE);
}

void CDS102Dlg::OnStep() 
{
// Mode(step)	
	iMoveStyle = 1;
	((CButton*)GetDlgItem(IDC_CW1))->SetWindowText("< (+) ");
	((CButton*)GetDlgItem(IDC_CW2))->SetWindowText("< (+) ");
	((CButton*)GetDlgItem(IDC_CCW1))->SetWindowText(" (-) >");
	((CButton*)GetDlgItem(IDC_CCW2))->SetWindowText(" (-) >");

	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->EnableWindow(TRUE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->EnableWindow(TRUE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->SetWindowText("position");
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->SetWindowText("position");
}

void CDS102Dlg::OnPoint() 
{
// Mode(point)	
	iMoveStyle = 2;
	((CButton*)GetDlgItem(IDC_CW1))->SetWindowText("point");
	((CButton*)GetDlgItem(IDC_CW2))->SetWindowText("point");
	((CButton*)GetDlgItem(IDC_CCW1))->SetWindowText("0 point");
	((CButton*)GetDlgItem(IDC_CCW2))->SetWindowText("0 point");

	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->EnableWindow(TRUE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->EnableWindow(TRUE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->SetWindowText("point");
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->SetWindowText("point");
}

void CDS102Dlg::OnOrg() 
{
// Mode(Origin)	
	iMoveStyle = 3;
	((CButton*)GetDlgItem(IDC_CW1))->SetWindowText("ORG");
	((CButton*)GetDlgItem(IDC_CW2))->SetWindowText("ORG");
	((CButton*)GetDlgItem(IDC_CCW1))->SetWindowText("ORG");
	((CButton*)GetDlgItem(IDC_CCW2))->SetWindowText("ORG");

	((CStatic*)GetDlgItem(IDC_STATIC_STYLE1))->EnableWindow(FALSE);
	((CStatic*)GetDlgItem(IDC_STATIC_STYLE2))->EnableWindow(FALSE);
}

void CDS102Dlg::OnMenuComm() 
{
//
// Com Port Setup
//
	CCommDlg clsCommDlg;
	clsCommDlg.iPort = iCommPort;
	if (IDOK == clsCommDlg.DoModal()){
		iCommPort = clsCommDlg.iPort;
	}
	Sleep(400);
	CommInit();
	SetUnit(1);
	SetUnit(2);
	UpdateData(FALSE);
	UpdateStatus();
	
}

void CDS102Dlg::OnMenuAxis1() 
{
//
// Axis1(X) setup
//
	CSetupDlg clsSetup;
	clsSetup.iAxisNumber = 1;
	clsSetup.DoModal();
	Sleep(400);
	CommInit();
	SetUnit(1);
	UpdateData(FALSE);
	UpdateStatus();
}

void CDS102Dlg::OnMenuAxis2() 
{
//
// Axis2(Y) setup
//
	CSetupDlg clsSetup;
	clsSetup.iAxisNumber = 2;
	clsSetup.DoModal();
	Sleep(400);
	CommInit();
	SetUnit(2);
	UpdateStatus();
}

void CDS102Dlg::OnDown(WPARAM wParam,LPARAM lParam){
//
// When a move button is pushed
// 
	if (UpdateData(TRUE) == FALSE) return;
	int iAxis;								// Axis No.
	int iMoveDirection;						//  Move Direction
	CString strCommand;						// Buffer

	// An Axis number and Move Direction are obtained from "wParam"
	if(wParam == IDC_CW1) {iAxis = 1;iMoveDirection = 5;}
	if(wParam == IDC_CW2) {iAxis = 2;iMoveDirection = 5;}
	if(wParam == IDC_CCW1){iAxis = 1;iMoveDirection = 6;}
	if(wParam == IDC_CCW2){iAxis = 2;iMoveDirection = 6;}
	
	// Check the speed(F)
	if(m_uiSpeed1<1 || m_uiSpeed1>999999){
		MessageBox("Illegal value at speed.");
		return;
	}
	if(m_uiSpeed2<1 || m_uiSpeed2>999999){
		MessageBox("Illegal value at speed.");
		return;
	}

	// speed(F) is updated
	switch(iAxis){
	case 1:
		iFSpeed[0] = m_uiSpeed1;
	case 2:
		iFSpeed[1] = m_uiSpeed2;
	}

	// Processing is distributed by the move method chosen.
	switch(iMoveStyle){
	case 0:
	// Move method = mode(continue)
		if (iTimer & iAxis) break;									// Nothing will be performed if the axis is moving now.
		strCommand.Format("FSpeed%d %d", iAxis, iFSpeed[iAxis-1]);	// The command which sets up drive speed is set up.
		Send(strCommand);
		strCommand.Format("Axi%d:Selsp %d:go %d", iAxis, iAxis, iMoveDirection);	// A move command is set up.
		Send(strCommand);
		if (iTimer == 0)  SetTimer(nTimerID,50,NULL);				// A timer is registered when the timer is not registered.
		iTimer = iTimer | int(pow(2, iAxis-1));						// The bit corresponding to the Axial number of iTimer is turned ON.
		break;
	case 1:
	case 2:
	case 3:
	// Move method = mode(not continue)
	// Since operation is started when a button is detached, nothing is done.
		break;
	}

}

void CDS102Dlg::OnUp(WPARAM wParam,LPARAM lParam){
//
// When a [move] button is detached
//
	int iAxis;			// Axial number
	int iMoveDirection;	// The move direction
	CString strCommand;
	double dPosition;

	// ԍAړшړʒu𓾂
	if(wParam == IDC_CW1) {iAxis = 1;iMoveDirection = 0;dPosition = m_dStep1;}
	if(wParam == IDC_CW2) {iAxis = 2;iMoveDirection = 0;dPosition = m_dStep2;}
	if(wParam == IDC_CCW1){iAxis = 1;iMoveDirection = 1;dPosition = m_dStep1;}
	if(wParam == IDC_CCW2){iAxis = 2;iMoveDirection = 1;dPosition = m_dStep2;}

	// The processing which separates a button is distributed by the selected move method.
	switch(iMoveStyle){
	case 0:
	// Move method = Mode(continue)
		strCommand.Format("axi%d:stop 0",iAxis);	// An axial stop command is set.
		Send(strCommand);							// A command is transmitted.
		CheckStop(iAxis);							// It waits until an axis stops.
		OnTimer(0);									// Coordinates and status are updated.

		// If all axis have stopped. A timer is stopped.
		if (iTimer == 0) {
			KillTimer(nTimerID);
		}
		break;

	case 1:
	// Move method = Mode(step)
		if (iTimer & iAxis) break;									// Nothing will be performed if the axis is moving now.
		strCommand.Format("FSpeed%d %d", iAxis, iFSpeed[iAxis-1]);	// The command which sets up drive speed is set up.
		Send(strCommand);
		strCommand.Format("Axi%d:Selsp %d:PULSE %g:go %d", iAxis, iAxis, dPosition,iMoveDirection);	// The command which moves is set up.
		Send(strCommand);
		if (iTimer == 0)  SetTimer(nTimerID,50,NULL);				// A timer is registered when the timer is not registered.
		iTimer = iTimer | int(pow(2 ,iAxis-1));						// The bit corresponding to the Axial number of iTimer is turned ON.
		break;

	case 2:
	// Move method = Mode(point)
		if (iTimer & iAxis) break;									// Nothing will be performed if the axis is moving now.
		strCommand.Format("FSpeed%d %d", iAxis, iFSpeed[iAxis-1]);	// The command which sets up drive speed is set up.
		Send(strCommand);
		if (iMoveDirection == 1) dPosition = 0.;					// A move position is set to 0 when the CCW button is pushed.
		strCommand.Format("Axi%d:Selsp %d:goabs %g", iAxis, iAxis, dPosition);	// A position move command is set up.
		Send(strCommand);
		if (iTimer == 0)  SetTimer(nTimerID,50,NULL);				// A timer is registered when the timer is not registered.
		iTimer = iTimer | int(pow(2,iAxis-1));						// The bit corresponding to the Axial number of iTimer is turned ON.
		break;
		
	case 3:
	// Move method = Mode(ORG)
		if (iTimer & iAxis) break;									// Nothing will be performed if the axis is moving now.
		strCommand.Format("FSpeed%d %d", iAxis, iFSpeed[iAxis-1]);	// The command which sets up drive speed is set up.
		Send(strCommand);
		strCommand.Format("Axi%d:Selsp %d:go org", iAxis, iAxis);	// The command which performs movement to the origin is set up.
		Send(strCommand);
		if (iTimer == 0)  SetTimer(nTimerID,50,NULL);				// A timer is registered when the timer is not registered.
		iTimer = iTimer | int(pow(2,iAxis-1));						// The bit corresponding to the Axial number of iTimer is turned ON.
		break;
	}
}

BOOL CDS102Dlg::Send(CString strMessage){
//
// A character string is transmitted to a Comm port.
//
	_variant_t vCommand;								// Buffer(MSComm)
	
	vCommand.SetString(strMessage+"\r");				// A transmitting command is set to a variable.
	if (m_MSComm.GetPortOpen() == FALSE) return FALSE;	// An error end is carried out if initialization of a Comm port is not settled.
	m_MSComm.SetOutput(vCommand);						// A transmitting character string is sent to a Comm port.
	return TRUE;
}

BOOL CDS102Dlg::Receive(CString& strMessage){
//
// A character string is received from a Comm port.
//
	time_t tStart;			// Reception start time
	time_t tNow;			// The present time
	_variant_t	vReceive;	// Receiving buffer

	strMessage = "";		// A receiving character string is initialized.
	time(&tStart);			// Receiving start time is obtained.
	do{
		if (m_MSComm.GetInBufferCount() > 0){		// It investigates whether the answer message collected on the buffer of a Comm port.
			vReceive = m_MSComm.GetInput();			// The buffer of a Comm port is read.
			strMessage += V_BSTR(&vReceive);		// The gained receiving data is connected with front data.
			if (strMessage.Right(1) == "\r"){		// t investigates whether it received to "\r".
				return TRUE;
			}
		}
		time (&tNow);								// The present time is obtained.
	}while(difftime(tNow, tStart) < LIMIT_TIME);	// In the case of a timeout, it exits from a loop.
	return FALSE;									// In the case of a timeout, "FALSE" is returned.
}

BOOL CDS102Dlg::SetCommPort(int iPort){
//
// communications processing setup
//
	if (m_MSComm.GetPortOpen() == TRUE){
		m_MSComm.SetPortOpen(FALSE);
	}
	m_MSComm.SetCommPort(iPort);
	m_MSComm.SetRTSEnable(iPort);
	m_MSComm.SetPortOpen(iPort);
	CString strIDN;
	CString strMsg;

	//
	// An "*IDN?" query is transmitted.
	// It checks whether it is DS102/DS112 series controller from the message which received.
	//
	if (Send("*IDN?") == FALSE){
		MessageBox("Communication of RS232C went wrong.");
		return FALSE;
	}
	if (Receive(strIDN) == FALSE){
		strMsg.Format("The controller is not connected to the port %d.\rOr cable wiring is different.", iPort);
		MessageBox(strMsg);
		return FALSE;
	}
	if (strIDN.Mid(0,10) !="SURUGA,DS1"){
		strMsg.Format("Apparatus other than DS102/DS112 series controller is connected to the port %d", iPort);
		MessageBox(strMsg);
		return FALSE;
	}

	if (CommInit() == FALSE){
		MessageBox("Abnormalities occurred in communication.");
		return FALSE;
	}
	iCommPort = iPort;
	
	return TRUE;
}	

BOOL CDS102Dlg::CommInit(){
//
// Initial communications processing: A drive parameter is received from a controller.
//
	CString strMessage;
	if (Send("axi1:selsp 1") == FALSE) return FALSE;		// The speed table of Axis1 is set as 1.
	if (Send("axi2:selsp 2") == FALSE) return FALSE;		// The speed table of Axis2 is set as 2.

	// Unit (display unit) is obtained.
	if (Send("axi1:unit?") == FALSE) return FALSE;
	if (Receive(strMessage) == FALSE) return FALSE;
	iUnit[0] = atoi(strMessage);
	if (Send("axi2:unit?") == FALSE) return FALSE;
	if (Receive(strMessage) == FALSE) return FALSE;
	iUnit[1] = atoi(strMessage);

	// Coordinates are acquired.
	if (Send("axi1:position?") == FALSE) return FALSE;
	if (Receive(strMessage) == FALSE) return FALSE;
	m_dPosition1=atof(strMessage);
	if (Send("axi2:position?") == FALSE) return FALSE;
	if (Receive(strMessage) == FALSE) return FALSE;
	m_dPosition2 = atof(strMessage);

	// Driver status is obtained.
	GetStatus1(1);
	GetStatus2(1);
	GetStatus3(1);
	GetStatus1(2);
	GetStatus2(2);
	GetStatus3(2);
	
	return TRUE;
}	

void CDS102Dlg::SetUnit(int iAxisNumber){
//
// A unit name is changed.
//

	CString strCaption;

	switch(iUnit[iAxisNumber-1]){
	case 0:
		strCaption = "PLS";
		break;
	case 1:
		strCaption = "um";
		break;
	case 2:
		strCaption = "mm";
		break;
	case 3:
		strCaption = "deg";
		break;
	case 4:
		strCaption = "mrad";
	}
	
	switch(iAxisNumber){
	case 1:
	// Axis 1
		m_strUnit1 = strCaption;
		break;		
	case 2:
	// Axis 2
		m_strUnit2 = strCaption;
		break;
	}
	UpdateData(FALSE);
}

BOOL CDS102Dlg::GetPosition(int iAxisNumber){
//
// Coordinates are acquired.
//
	CString strCommand;		// The buffer for outgoing messages
	CString strPosition;	// The buffer which receives a character string

	strCommand.Format("axi%d:Position?",iAxisNumber);			// The command which acquires coordinates is set up.
	if (Send(strCommand) == FALSE) return FALSE;				// A command is transmitted.
	if (Receive(strCommand) == FALSE) return FALSE;				// A response massage is obtained.
	strPosition = strCommand.Mid(0,strCommand.GetLength()-1);	// The character string which removed '\r' is obtained.

	switch(iAxisNumber){
	case 1:
	// Axis 1
		m_dPosition1 = atof(strCommand);
		((CEdit*)GetDlgItem(IDC_POSITION1))->SetWindowText(strPosition);
		break;

	case 2:
	// Axis 2
		m_dPosition2 = atof(strCommand);
		((CEdit*)GetDlgItem(IDC_POSITION2))->SetWindowText(strPosition);
		break;
	}
	return TRUE;
}

BOOL CDS102Dlg::GetFSpeed(int iAxisNumber){
//
// Drive speed is obtained.
//
	CString strCommand;	// The buffer for messages

	strCommand.Format("FSpeed%d?",iAxisNumber);		// The command which acquires coordinates is set up.
	if (Send(strCommand) == FALSE) return FALSE;	// A command is transmitted.
	if (Receive(strCommand) == FALSE) return FALSE;	// A response massage is obtained.
	iFSpeed[iAxisNumber-1] = atoi(strCommand);		// A response message is changed into a numerical value.

	switch(iAxisNumber){							// The obtained speed is put into a member variable.
	case 1:
		m_uiSpeed1 = iFSpeed[0];					
		break;
	case 2:
		m_uiSpeed2 = iFSpeed[1];
		break;
	}
	UpdateData(FALSE);								// A screen is updated.
	return TRUE;
}

void CDS102Dlg::OnEmg() 
{
	//
	// Processing when pushing a stop button
	//
	Send("stop 0");	// All axial scram commands are transmitted.
	CheckStop(0);	// It waits for a stop of all axes. 
	GetPosition(1);	// The coordinates of an Axis1 are updated.
	GetPosition(2);	// The coordinates of an Axis2 are updated.
	GetStatus1(1);	// The status of an Axis1 is updated.
	GetStatus1(2);	// The status of an Axis2 is updated.
	UpdateData(FALSE);	// A screen is updated.
}

BOOL CDS102Dlg::CheckStop(int iAxisNumber){
//
// It stands by until the specified axis stops.
//
// When "iAxisNumber" is zero ,
// It checks whether all axial stops have been carried out.
//
	CString strMessage;
	int iMotion;

	if(iAxisNumber == 0) iAxisNumber = 255;							// When checking a stop of all the axes, 8 bits of low ranks are turned ON altogether.
	else				 iAxisNumber = int(pow(2, iAxisNumber-1));	// When checking a stop of one axes, The bit corresponding to a specification axis is turned ON.
	while(1){
		if (Send("Motionall?") == FALSE) return FALSE;	// The status demand command of all axes of operation is transmitted.
		if (Receive(strMessage) == FALSE) return FALSE;	// A response massage is obtained.
		iMotion = atoi(strMessage);						// A response massage is changed into a numerical value.
		if ((iMotion & iAxisNumber) == FALSE) break;	// AND of a response massage and a selected axis is taken, and if it is 0, it escapes from a loop.
		CheckMessage();									// The message of Windows is processed.
		Sleep(20);										// 20msec wait is carried out.
	}
	return TRUE;
}

void CDS102Dlg::OnClear1() 
{
	Send("Axi1:Position 0");	// The command which sets coordinates to "0" is transmitted.
	m_dPosition1 = 0.;			// A position is set to 0.
	UpdateData(FALSE);			// A screen is updated.
}

void CDS102Dlg::OnClear2() 
{
	Send("Axi2:Position 0");	// The command which sets coordinates to "0" is transmitted.
	m_dPosition2 = 0.;			// A position is set to 0.
	UpdateData(FALSE);			// A screen is updated.
}

BOOL CDS102Dlg::GetStatus1(int iAxisNumber){
//
// Status 1 acquisition
//
	CString strCommand;

	strCommand.Format("Axi%d:sb1?",iAxisNumber);	// A status 1 demand command is set up.
	if (Send(strCommand) == FALSE) return FALSE;	// A command is transmitted.
	if (Receive(strCommand) == FALSE) return FALSE;	// A response massage is obtained.
	iStatus1[iAxisNumber-1] = atoi(strCommand);		// Status 1 is updated.
	return TRUE;
}

BOOL CDS102Dlg::GetStatus2(int iAxisNumber){
//
// Status 2 acquisition
//
	CString strCommand;

	strCommand.Format("Axi%d:sb2?",iAxisNumber);	// A status 2 demand command is set up.
	if (Send(strCommand) == FALSE) return FALSE;	// A command is transmitted.
	if (Receive(strCommand) == FALSE) return FALSE;	// A response massage is obtained.
	iStatus2[iAxisNumber-1] = atoi(strCommand);		// Status 2 is updated.
	return TRUE;
}

BOOL CDS102Dlg::GetStatus3(int iAxisNumber){
//
// Status 3 acquisition
//
	CString strCommand;

	strCommand.Format("Axi%d:sb3?",iAxisNumber);	// A status 3 demand command is set.
	if (Send(strCommand) == FALSE) return FALSE;	// A command is transmitted.
	if (Receive(strCommand) == FALSE) return FALSE;	// A response massage is obtained.
	iStatus3[iAxisNumber-1] = atoi(strCommand);		// Status 3 is updated.
	return TRUE;
}


void CDS102Dlg::OnTimer(UINT nIDEvent) 
{
	// 
	
	GetStatus1(1);								// The status of an axis 1 is obtained.
	if (iStatus1[0] & MLIMIT) GetStatus2(1);	// Status 2 is obtained when the limit is being detected.

	GetStatus1(2);								// The status of an axis 2 is obtained.
	if (iStatus1[1] & MLIMIT) GetStatus2(2);	// Status 2 is obtained when the limit is being detected.

	UpdateStatus();								// The status on a screen is updated.
	if ((iStatus1[0] & MOVING) == FALSE) iTimer = iTimer & 0x0fe;	// When an axis 1 is not operating, the bit 1 of "iTimer" is turned OFF.
	if ((iStatus1[1] & MOVING) == FALSE) iTimer = iTimer & 0x0fd;	// When an axis 2 is not operating, the bit 2 of "iTimer" is turned OFF.

	if (iTimer == 0) {							// A timer is stopped when all axes have stopped.
		KillTimer(nIDEvent);
	}

	GetPosition(1);								// The coordinates of an axis 1 are updated.
	GetPosition(2);								// The coordinates of an axis 2 are updated.

	if (nIDEvent == 0) return;					// "CDialog::OnTimer()" is avoided when not called from timer interruption.

	CDialog::OnTimer(nIDEvent);
}

void CDS102Dlg::UpdateStatus(){
//
// Limit status is reflected in a screen.
// 
	((CButton*)GetDlgItem(IDC_CW1 ))->EnableWindow(!( ((iStatus2[0] & CWML) == CWML) & ((iStatus1[0] & MLIMIT) == MLIMIT) ));
	((CButton*)GetDlgItem(IDC_CW2 ))->EnableWindow(!( ((iStatus2[1] & CWML) == CWML) & ((iStatus1[1] & MLIMIT) == MLIMIT) ));
	((CButton*)GetDlgItem(IDC_CCW1))->EnableWindow(!( ((iStatus2[0] & CCWML) == CCWML) & ((iStatus1[0] & MLIMIT) == MLIMIT) ));
	((CButton*)GetDlgItem(IDC_CCW2))->EnableWindow(!( ((iStatus2[1] & CCWML) == CCWML) & ((iStatus1[1] & MLIMIT) == MLIMIT) ));
}

void CDS102Dlg::CheckMessage(){
//
// The message of Windows is processed.
//
    MSG msg;
    if(::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) != 0){
        ::TranslateMessage(&msg);
        ::DispatchMessage(&msg);
    }
}

void CDS102Dlg::OnEnd() 
{
	// 
	OnCancel();

}

